"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function DropdownList(props) {
  const ref = (0, _react.useRef)();
  const [itemList, setItemList] = (0, _react.useState)(false);
  const [value, setValue] = (0, _react.useState)('');

  const useClickOutside = ref => {
    (0, _react.useEffect)(() => {
      const handleClickOutside = event => {
        if (ref.current && !ref.current.contains(event.target)) {
          setItemList(false);
        }
      };

      document.addEventListener("mousedown", handleClickOutside);
      return () => {
        document.removeEventListener("mousedown", handleClickOutside);
      };
    }, [ref]);
  };

  useClickOutside(ref);

  const handleOpenItemList = () => {
    setItemList(true);
  };

  const handleCloseItemList = () => {
    setItemList(false);
  };

  const handleChange = event => {
    setValue(event.target.outerText);
  };

  (0, _react.useEffect)(() => {
    if (value) {
      return setItemList(false);
    }
  }, [value]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: 'container',
    style: {
      boxShadow: itemList && !props.darkMode ? '0px 8px 19px rgba(0, 0, 0, 0.26)' : itemList && props.darkMode ? '0px 2px 24px #000000' : ''
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: props.darkMode === true ? 'header darkMode' : 'header lightMode',
    onClick: handleOpenItemList,
    style: {
      borderRadius: itemList ? '15px 15px 0 0' : '',
      backgroundColor: itemList && props.darkMode === true ? '#1A1C1E' : ''
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: 'header-text',
    style: {
      marginBottom: itemList ? '-6.5px' : ''
    }
  }, value || props.placeholder), /*#__PURE__*/_react.default.createElement("div", {
    className: 'header-icons'
  }, /*#__PURE__*/_react.default.createElement("div", {
    onClick: handleOpenItemList,
    className: 'arrow-position-down',
    style: {
      display: itemList ? 'none' : 'flex'
    }
  }, /*#__PURE__*/_react.default.createElement("img", {
    className: props.darkMode === true ? 'arrow-icon-down-dark' : 'arrow-icon-down'
  })), /*#__PURE__*/_react.default.createElement("div", {
    onClick: handleCloseItemList,
    className: 'arrow-position-up',
    style: {
      display: itemList ? 'flex' : 'none',
      marginBottom: itemList ? '-6.5px' : ''
    }
  }, /*#__PURE__*/_react.default.createElement("img", {
    className: props.darkMode === true ? 'arrow-icon-up-dark' : 'arrow-icon-up'
  })))), /*#__PURE__*/_react.default.createElement("div", {
    ref: ref,
    style: {
      display: itemList ? 'flex' : 'none'
    },
    className: props.darkMode === true ? 'darkMode-itemList items-list' : 'items-list lightMode-itemList'
  }, props.data.map((text, index) => {
    return /*#__PURE__*/_react.default.createElement("div", {
      onClick: handleChange,
      className: 'item',
      style: {
        backgroundColor: value === text && !props.darkMode ? '#ffffff' : value === text && props.darkMode === true ? '#272A30' : ''
      }
    }, /*#__PURE__*/_react.default.createElement("div", {
      id: index,
      className: 'item-text'
    }, text));
  })));
}

var _default = DropdownList;
exports.default = _default;